bool check_3x4keyboard_clicked() {  // just a function that checks if some key on the keyboard was pressed
  digitalWrite(keyboard3x4_column1, HIGH);
  digitalWrite(keyboard3x4_column2, HIGH);
  digitalWrite(keyboard3x4_column3, HIGH);

  if (analogRead(keyboard3x4_row1) >= 4000) {
    return true;
  } else if (analogRead(keyboard3x4_row2) >= 4000) {
    return true;
  } else if (analogRead(keyboard3x4_row3) >= 4000) {
    return true;
  } else if (analogRead(keyboard3x4_row4) >= 4000) {
    return true;
  }

  return false;
}

String readCodeFrom3x4keyboard(bool codeChange) {  // the parameter "codeChange" is just to prevent a loop, look further down
  String input = "";
  int currentpower = 1;

  while (true) {
    switch (currentpower) {
      case 1:
        digitalWrite(keyboard3x4_column3, LOW);
        digitalWrite(keyboard3x4_column1, HIGH);
        currentpower = 2;
        
        if (analogRead(keyboard3x4_row1) >= 4000) {
          int timeAtClick = millis();
          while (analogRead(keyboard3x4_row1) >= 4000) {}
          if(millis() - timeAtClick >= 2000 && codeChange) {  // if the button was pressed longer than 2 seconds then... (here's the loop-preventing codeChange parameter)
            Serial.println("Changing code...");
            digitalWrite(codeChangeLED, HIGH);  // turn on the led that indicates code change
            digitalWrite(typeOldCodeLED, HIGH);  // turn on the led that prompts to type in the old code

            // read the old code and check if it's correct
            String currentCode = readCodeFrom3x4keyboard(false);
            while(currentCode != getCode()) { blinkLED(wrongCodeLED, 700); currentCode = readCodeFrom3x4keyboard(false); }
            
            // show that now the new code has to be submitted (only if the old code was right)
            digitalWrite(typeOldCodeLED, LOW);
            digitalWrite(newCodeLED, HIGH);
            
            // read the new code
            String newCode = readCodeFrom3x4keyboard(false);
            while(newCode.length() != 8) { blinkLED(invalidCodeLED, 700); newCode = readCodeFrom3x4keyboard(false); }  // make sure the code is 8 numbers long
            
            // prompt the user to repeat the code
            digitalWrite(newCodeLED, LOW);
            digitalWrite(newCodeRepeatLED, HIGH);
            
            // read repeated new code
            String newCodeRepeat = readCodeFrom3x4keyboard(false);
            while(newCode != newCodeRepeat) { blinkLED(wrongCodeLED, 700); newCodeRepeat = readCodeFrom3x4keyboard(false); }
            
            // ...and finally set the code
            setCode(newCode);

            // turn off the used leds
            digitalWrite(newCodeRepeatLED, LOW);
            digitalWrite(codeChangeLED, LOW);

            // debug message
            Serial.println("Changed code.");

            return "newCodeFinished";  // statuscode "newCodeFinished" (just shows that a new code was set)
          } else {  // if pressed short, just remove one number from the read code
            input = input.substring(0, input.length() - 1);
          }
          delay(10);
        } else if (analogRead(keyboard3x4_row2) >= 4000) {
          while (analogRead(keyboard3x4_row2) >= 4000) {}
          delay(10);
          input += "7";
        } else if (analogRead(keyboard3x4_row3) >= 4000) {
          while (analogRead(keyboard3x4_row3) >= 4000) {}
          delay(10);
          input += "4";
        } else if (analogRead(keyboard3x4_row4) >= 4000) {
          while (analogRead(keyboard3x4_row4) >= 4000) {}
          delay(10);
          input += "1";
        }
        break;
      case 2:
        digitalWrite(keyboard3x4_column1, LOW);
        digitalWrite(keyboard3x4_column2, HIGH);
        currentpower = 3;

        if (analogRead(keyboard3x4_row1) >= 4000) {
          while (analogRead(keyboard3x4_row1) >= 4000) {}
          delay(10);
          input += "0";
        } else if (analogRead(keyboard3x4_row2) >= 4000) {
          while (analogRead(keyboard3x4_row2) >= 4000) {}
          delay(10);
          input += "8";
        } else if (analogRead(keyboard3x4_row3) >= 4000) {
          while (analogRead(keyboard3x4_row3) >= 4000) {}
          delay(10);
          input += "5";
        } else if (analogRead(keyboard3x4_row4) >= 4000) {
          while (analogRead(keyboard3x4_row4) >= 4000) {}
          delay(10);
          input += "2";
        }
        break;
      case 3:
        digitalWrite(keyboard3x4_column2, LOW);
        digitalWrite(keyboard3x4_column3, HIGH);
        currentpower = 1;

        if (analogRead(keyboard3x4_row1) >= 4000) {
          while (analogRead(keyboard3x4_row1) >= 4000) {}
          delay(10);
          return input;
        } else if (analogRead(keyboard3x4_row2) >= 4000) {
          while (analogRead(keyboard3x4_row2) >= 4000) {}
          delay(10);
          input += "9";
        } else if (analogRead(keyboard3x4_row3) >= 4000) {
          while (analogRead(keyboard3x4_row3) >= 4000) {}
          delay(10);
          input += "6";
        } else if (analogRead(keyboard3x4_row4) >= 4000) {
          while (analogRead(keyboard3x4_row4) >= 4000) {}
          delay(10);
          input += "3";
        }
        break;
    }
  }
}
